/*
 * This program was written by LJ LongWing (lj@remedylegacy.com) and he holds the copyright.
 * This tool is provided for free and can be distributed at will, for private or commercial use.
 * Disclaimer of Warranty.
		THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING 
		THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM AS IS WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR 
		IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. 
		THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, 
		YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

	Limitation of Liability.
		IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO 
		MODIFIES AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, 
		INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED 
		TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM 
		TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 
 */

package com.apl;

import java.util.List;

import com.bmc.arsys.api.ARException;
import com.bmc.arsys.api.ARServerUser;
import com.bmc.arsys.api.Entry;
import com.bmc.arsys.api.QualifierInfo;
import com.bmc.arsys.api.Value;


public class GetRASPassword {
	String server = "";
	String user = "";
	String pass = "";
	int tcpPort = 0;

	public GetRASPassword(String server, String user, String pass, int tcpPort) {
		super();
		this.server = server;
		this.user = user;
		this.pass = pass;
		this.tcpPort = tcpPort;
	}

	public String run() {
			ARServerUser conn = new ARServerUser(user, pass, null, server, tcpPort);
			
			try {
				conn.login();
			} catch (ARException e) {
				return "ERROR performing login for getRAS function: " + e.getMessage();
			}
			
			try {
				if (!conn.isAdministrator()) {
					return "ERROR: Specified user is not an Admin User";
				}
			} catch (ARException e) {
				return "ERROR determining if " + user + " is an administrator: " + e.getMessage();
			}
			
			String qualS = "'Configuration Tag' = \"Remedy-App-Service-Password\"";
			QualifierInfo localQual;
			try {
				localQual = conn.parseQualification("Configuration ARDBC", qualS);
			} catch (ARException e) {
				return "ERROR parsing getRAS qualification: " + e.getMessage();
			}

			int fidTagID = 536870913;
			int fidValueID = 536870914;
			
			int[] tableFields = {fidTagID, fidValueID};

			List<Entry> tableEntry;
			try {
				tableEntry = conn.getListEntryObjects("Configuration ARDBC", localQual, 0, 0, null, tableFields, false, null);
			} catch (ARException e) {
				return "ERROR geting getRAS entry: " + e.getMessage();
			}
			
			conn.logout();
			
			for (Entry entry : tableEntry) {
				for (java.util.Map.Entry<Integer, Value> entryMap : entry.entrySet()) {
					int entryKey = entryMap.getKey();
					
					if (entryKey == fidValueID) {
						return entryMap.getValue().toString();
					}
				}
			}
		return null;
	}
}
