/*
 * This program was written by LJ LongWing (lj@remedylegacy.com) and he holds the copyright.
 * This tool is provided for free and can be distributed at will, for private or commercial use.
 * Disclaimer of Warranty.
		THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING 
		THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM AS IS WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR 
		IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. 
		THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, 
		YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

	Limitation of Liability.
		IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO 
		MODIFIES AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, 
		INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED 
		TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM 
		TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 
 */

package com.apl;

import java.net.*;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.apache.log4j.Logger;

import java.io.*;

public class SocketThread extends Thread {
	private static Logger logger = Logger.getLogger(Daemon.class);

	private int monitorPort = 0;

	public SocketThread(int monitorPort) {
		super("ARServerOnlineSocketThread");
		this.monitorPort = monitorPort;
	}

	public void run() {
		while (true) {
			if (Daemon.alive) {
				try {
					Daemon.serverSocket = new ServerSocket(monitorPort);
					Socket socket = Daemon.serverSocket.accept();
					DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
					Date date = new Date();
					PrintWriter out = new PrintWriter(socket.getOutputStream(), true);
					out.println("Server Online: " + dateFormat.format(date));
					out.close();
					socket.close();
					Daemon.serverSocket.close();
				} catch (SocketException e) {
					
				} catch (IOException e) {
					logger.error("Unable to open socket '" + monitorPort + "'.  Please restart the monitor.");
					System.exit(1);
				}
				//System.out.println("Waiting for Connect");
			} else {
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {}
			}
		}
		//serverSocket.close();
	}
}